﻿Imports System.Runtime.InteropServices

Public Class Credits

    <System.Runtime.InteropServices.DllImport("credui.dll", EntryPoint:="CredUIPromptForWindowsCredentials", CharSet:=CharSet.Unicode)> <CLSCompliant(False)> _
    Public Shared Function CredUIPromptForWindowsCredentials(ByRef pUiInfo As CREDUI_INFO, _
                                ByVal dwAuthError As UInt32, _
                                ByRef pulAuthPackage As UInt32, _
                                ByVal pvInAuthBuffer As IntPtr, _
                                ByVal ulInAuthBufferSize As UInt32, _
                                ByRef ppvOutAuthBuffer As IntPtr, _
                                ByRef pulOutAuthBufferSize As UInt32, _
                                <MarshalAs(UnmanagedType.Bool)> ByRef pfSave As Boolean, _
                                ByVal dwFlags As CredUIWinFlags) As CredUIReturnCodes
    End Function

    '<StructLayout(LayoutKind.Sequential, CharSet:=CharSet.Unicode)>
    Public Structure CREDUI_INFO
        Public cbSize As UInt32
        Public hwndParent As IntPtr
        Public pszMessageText As String
        Public pszCaptionText As String
        Public hbmBanner As IntPtr
    End Structure

    '<Flags()> _
    Public Enum CredUIWinFlags As Integer
        CredUIWin_Generic = &H1
        CredUIWin_Checkbox = &H2
        CredUIWin_AuthPackage_Only = &H10
        CredUIWin_InCred_Only = &H20
        CredUIWin_Enumerate_Admins = &H100
        CredUIWin_Enumerate_CurrentUser = &H200
        CredUIWin_Secure_Prompt = &H1000
        CredUIWin_Pack_32_Wow = &H10000000
    End Enum

    Public Enum CredUIReturnCodes As Integer
        NO_ERROR = 0
        ERROR_CANCELLED = 1223
        ERROR_NO_SUCH_LOGON_SESSION = 1312
        ERROR_NOT_FOUND = 1168
        ERROR_INVALID_ACCOUNT_NAME = 1315
        ERROR_INSUFFICIENT_BUFFER = 122
        ERROR_INVALID_PARAMETER = 87
        ERROR_INVALID_FLAGS = 1004
    End Enum

    Public Sub Show(ByVal handle As System.IntPtr)
        Dim save As Boolean = False
        Dim errorcode As Integer = 0
        Dim dialogReturn As UInt32
        Dim authPackage As UInt32 = 0
        Dim outCredBuffer As IntPtr
        Dim outCredSize As UInt32

        Dim credui As CREDUI_INFO = New CREDUI_INFO()
        credui.cbSize = Marshal.SizeOf(credui)
        credui.pszCaptionText = "Connect to your application"
        credui.pszMessageText = "Enter your credentials!"
        credui.hwndParent = handle

        dialogReturn = CredUIPromptForWindowsCredentials(credui, errorcode, authPackage, 0, 0, outCredBuffer, outCredSize, save, 0)

        If (dialogReturn = 0) Then
            'Handle the buffer
        End If
    End Sub
End Class