﻿Imports System.Runtime.InteropServices
Imports System.Text

Friend Class SafeNativeMethods
    Private Sub New()
    End Sub

    Public Const CredMaxPasswordLength As Integer = 256
    Public Const CredMaxUsernameLength As Integer = (256 + 1 + 256)
    Public Const CredMaxDomainNameLength As Integer = (256 + 1 + 80)
    Public Const CredMaxMessageLength As Integer = 32767
    Public Const CredMaxCaptionLength As Integer = 128

    <Flags()> _
    Public Enum CredUIFlags As Integer
        Generic = &H1
        Checkbox = &H2
        AuthPackageOnly = &H10
        InCredOnly = &H20
        Enumerat_Admins = &H100
        EnumerateCurrentUser = &H200
        SecurePrompt = &H1000
        Pack32Wow = &H10000000
    End Enum

    <StructLayout(LayoutKind.Sequential, CharSet:=CharSet.Unicode)> _
    Public Structure CredUIInfo
        Dim cbSize As Integer
        Dim hwndParent As IntPtr
        Dim pszMessageText As String
        Dim pszCaptionText As String
        Dim hbmBanner As IntPtr
    End Structure

    <DllImport("credui.dll", ExactSpelling:=False, SetLastError:=True, CharSet:=CharSet.Unicode)> _
    Public Shared Function CredUIPromptForWindowsCredentials(ByRef pUiInfo As CredUIInfo, ByVal dwAuthError As Integer, ByRef pulAuthPackage As Integer, ByVal pvInAuthBuffer As IntPtr, ByVal ulInAuthBufferSize As Integer, <Out()> ByRef ppvOutAuthBuffer As IntPtr, ByRef pulOutAuthBufferSize As Integer, <MarshalAs(UnmanagedType.Bool)> ByRef pfSave As Boolean, ByVal dwFlags As Integer) As Integer
    End Function

    <DllImport("credui.dll", ExactSpelling:=False, SetLastError:=True, CharSet:=CharSet.Unicode)> _
    Public Shared Function CredUnPackAuthenticationBuffer(ByVal dwFlags As Integer, ByVal pAuthBuffer As IntPtr, ByVal cbAuthBuffer As Integer, ByVal pszUserName As StringBuilder, ByRef pcchMaxUserName As Integer, ByVal pszDomainName As StringBuilder, ByRef pcchMaxDomainame As Integer, ByVal pszPassword As StringBuilder, ByRef pcchMaxPassword As Integer) As Integer
    End Function

End Class