﻿Imports System.IO
Imports System.Net
Imports System.Text
Imports System.Collections.Generic

Public Class FtpClient

    Private _username As String
    Private _password As String
    Private _server As String
    Private _remoteFile As String


    ' The UploadFile method will upload an Object of the WebPage type to the
    ' server.
    Public Sub uploadFile(ByVal newPage As WebPage, ByVal remoteFolderName As String, ByVal remoteFileName As String)

        If Not (newPage Is Nothing) Then
            Dim htmlCode As String
            htmlCode = newPage.processedHTML

            Try
                ' Generate the client credentials
                Dim client As New WebClient()
                client.Credentials = New NetworkCredential(_username, _password)

                ' Generate an URI object with the connection String
                Dim uploadURI As Uri
                uploadURI = buildConnectionString(remoteFolderName, remoteFileName)
                Debug.Print(uploadURI.ToString())
                ' Test the URI and finally upload it to FTP server
                If (uploadURI Is Nothing) Then
                    MsgBox("invalid URI String!")
                Else
                    ' Upload the HTML code to the FTP server
                    client.UploadString(uploadURI, htmlCode)
                End If

            Catch ex As Exception
                Debug.Print("Ex while uploading: " & ex.Message)

            Finally
                ' TODO: add some code here
            End Try
        End If
    End Sub



    Private Function buildConnectionString(ByVal remoteFolder As String, ByVal remoteFileName As String) As Uri
        ' Build the newPath variable. 
        ' _server should contain valid hostname (without dashes)
        ' _remoteFolder should start with a / character. It must also end with the / sign
        ' remoteFilename should contain the actual file. It should match the pattern of a valid filename (without any / signs)
        Dim newPath As String
        newPath = "ftp://"
        newPath += _server
        newPath += remoteFolder
        newPath += remoteFileName

        Dim newPathUri As Uri
        newPathUri = New Uri(newPath)

        If newPathUri.IsWellFormedOriginalString() Then
            Return newPathUri
        Else
            Return Nothing
        End If
    End Function




    Public Sub New(ByVal server As String, ByVal username As String, ByVal password As String)
        _username = username
        _password = password
        _server = server
    End Sub
End Class
