﻿Public Class WebPage

    ' This code contains the hard coded HTML page that will be uploaded each time the K8055
    ' changes.
    Private variables As New Collection

    Private templateHTML = <html>
                               <head>
                                   <title>K8055 Web Uploader</title>
                               </head>

                               <body>
                                   <h1>Current state of your K8055 card:</h1>
                                   <p>This page gives you an overview of the current inputs of your K8055 card.</p>

                                   <table border="1">
                                       <tr>
                                           <td>Channel</td>
                                           <td>Status</td>
                                       </tr>
                                       <tr>
                                           <td>01</td>
                                           <td>%INP1%</td>
                                       </tr>
                                       <tr>
                                           <td>02</td>
                                           <td>%INP2%</td>
                                       </tr>
                                       <tr>
                                           <td>03</td>
                                           <td>%INP3%</td>
                                       </tr>
                                       <tr>
                                           <td>04</td>
                                           <td>%INP4%</td>
                                       </tr>
                                       <tr>
                                           <td>05</td>
                                           <td>%INP5%</td>
                                       </tr>
                                   </table>

                                   <hr/>
                                   <p>This page was last uploaded at %DATE%</p>

                               </body>
                           </html>





    ' This property returns the source HTML code
    Public ReadOnly Property HTML() As String
        Get
            Return templateHTML.ToString()
        End Get
    End Property


    ' This property returns the processed HTML code.
    Public ReadOnly Property processedHTML() As String
        Get
            Dim finalHTML As String
            finalHTML = templateHTML.ToString()

            For Each var As Variable In variables
                finalHTML = finalHTML.Replace(var.naam, var.value)
            Next

            Return finalHTML.ToString()
        End Get
    End Property


    ' This method adds a variable to the class. Variables in your HTML that are not added with this
    ' method, will not be translated.
    Public Sub addVariable(ByVal name As String, ByVal value As String)
        Dim var As New Variable(name, value)
        variables.Add(var)
    End Sub


End Class